using System;
using System.Runtime.InteropServices;

namespace MyEventIO
{
	#region Classes
	public static class EventIO
	{
        // Imports to wrap native event functions to a selfmade event class.
        // The handle property of an autoreset-event does not work correctly.
        // Using an autoreset-event within the CANReadThread() should work like this
        // but the Handle property returns an invalid value:
        // System.Threading.AutoResetEvent RcvEvent;
        // UInt32 paramval;
        // RcvEvent = new System.Threading.AutoResetEvent;
        // paramval = Convert.ToUInt32(hRcvEvent.Handle.ToInt32());
        // res = PCANBasic.SetValue(hBus, TPCANParameter.PCAN_RECEIVE_EVENT, ref paramval, sizeof(uint));
        //
        [DllImport("coredll.dll", SetLastError = true)]
        public static extern IntPtr CreateEvent(
            IntPtr eventAttributes,
            [MarshalAs(UnmanagedType.Bool)] 
            bool manualReset,
            [MarshalAs(UnmanagedType.Bool)] 
            bool initialState,
            string name);


        [DllImport("coredll.dll", SetLastError = true)]
        public static extern uint WaitForSingleObject(
            IntPtr handle,
            int millis);


        [DllImport("coredll.dll", SetLastError = true)]
        [return: MarshalAs(UnmanagedType.Bool)]
        public static extern bool EventModify(
            IntPtr handle,
            uint  func);

        
        public static bool SetEvent(
            IntPtr handle)
        {
            return EventModify(handle, 3);
        }
	}
	#endregion
}
